var ebook = (function(){
    var data = {};
    var listData = {};
    var WW;
    var WH;
    var RATIO;
    var currPage = 0;
    var firstPage = 0;
    var lastPage = 0;
    var zoomLangth = 1;
    var zoomPointOffset;
    var zoomEnd = true;

    var printPageImg = $("<img src=pages/" + 1 + ".jpg></img>");
    var initTimer = 0;
    var isTimerInited = false;

    var flipbook = $('.magazine');
    var flipbookViewPort = $('.magazine-viewport');
    var pageIndexField = $('.page-index-field');
    var display = 'double';

    window.isInit = false;
    window.isMobile = true;



    /****************
    * turn.js
    ****************/
    function zoomInter(){
        $('.zoom-icon').bind('mouseover', function() {
            if ($(this).hasClass('zoom-icon-in'))
                $(this).addClass('zoom-icon-in-hover');

            if ($(this).hasClass('zoom-icon-out'))
                $(this).addClass('zoom-icon-out-hover');
        }).bind('mouseout', function() {
            if ($(this).hasClass('zoom-icon-in'))
                $(this).removeClass('zoom-icon-in-hover');

            if ($(this).hasClass('zoom-icon-out'))
                $(this).removeClass('zoom-icon-out-hover');

        }).bind('click', function() {
            if ($(this).hasClass('zoom-icon-in'))
                $('.magazine-viewport').zoom('zoomIn');
            else if ($(this).hasClass('zoom-icon-out'))
                $('.magazine-viewport').zoom('zoomOut');
        });
    }
    function updateDepth(book, newPage) {
        var page = book.turn('page'),
            pages = book.turn('pages'),
            depthWidth = 16*Math.min(1, page*2/pages);

        newPage = newPage || page;

        if (newPage>3)
            $('.sj-book .p2 .depth').css({
                width: depthWidth,
                left: 20 - depthWidth
            });
        else
            $('.sj-book .p2 .depth').css({width: 0});
            depthWidth = 16*Math.min(1, (pages-page)*2/pages);
        if (newPage<pages-3)
            $('.sj-book .p111 .depth').css({
                width: depthWidth,
                right: 20 - depthWidth
            });
        else
            $('.sj-book .p111 .depth').css({width: 0});
    }
    function loadApp(){
        var w = 0;
        var h = 0;
        $('#canvas').fadeIn(1000);

        // Check if the CSS was already loaded
        if (flipbook.width()==0 || flipbook.height()==0) {
            setTimeout(loadApp, 10);
            return;
        }

        // Create the flipbook
        if( methods.checkMobileDevice() ){
            // w = WW;
            // h = WW * RATIO;
            w = data.W;
            h = data.W * RATIO;
            display = 'single';
        }else{
            w = data.W;
            h = data.H;
        }

        flipbook.turn({
            // Magazine width
            width: w,

            // Magazine height
            height: h,

            // Duration in millisecond
            duration: 1000,

            // Hardware acceleration
            acceleration: !isChrome(),

            // Enables gradients
            gradients: true,

            // Auto center this flipbook
            autoCenter: true,

            // Elevation from the edge of the flipbook when turning a page
            elevation: 50,

            // The number of pages
            pages: data.page,

            display:display,

            // Events
            when: {
                turning: function(event, page, view){
                    var book = $(this),
                        currentPage = book.turn('page'),
                        pages = book.turn('pages');

                    // Update the current URI

                    Hash.go('page/' + page).update();

                    $('.curr-page').text(page);

                    // Show and hide navigation buttons

                    disableControls(page);

                    $('.page-index-wrap input').val( page );
                    menuOff();



                    // $('.thumbnails .page-'+currentPage).
                    // parent().
                    // removeClass('current');
                    //
                    // $('.thumbnails .page-'+page).
                    // parent().
                    // addClass('current');
                },

                turned: function(event, page, view) {
                    var book = $(this);

                    disableControls(page);
                    $(this).turn('center');
                    if (page==1) {
                        $(this).turn('peel', 'br');
                    }
                    $('#slider').slider('value', getViewNumber(book, page));
                },

                missing: function (event, pages) {
                    // Add pages that aren't in the magazine

                    for (var i = 0; i < pages.length; i++)
                        addPage(pages[i], $(this));
                },

                end: function(e, pageObj) {

                    var book = $(this);

                    updateDepth(book);

                    setTimeout(function() {

                        $('#slider').slider('value', getViewNumber(book));

                    }, 1);

                    moveBar(false);

                },
            },

        });
        $('.one-page').on('click',function(){
            flipbook.turn('display', 'single').turn('size', w/2, h).turn("center");
            display = 'single';
            window.turnjsDisplay = 'single';
            $('.button-wrap').css('width','87%')
        });

        $('.two-page').on('click',function(){
            flipbook.turn('display', 'double').turn('size', w, h).turn("center");
            display = 'double';
            window.turnjsDisplay = 'double';
            /*$('.button-wrap').css('width','80%')*/
        });

        // Slider
        $( "#slider" ).slider({
            min: 1,
            max: 100,

            start: function(event, ui) {

                if (!window._thumbPreview) {
                    // _thumbPreview = $('<div />', {'class': 'thumbnail'}).html('<div></div>');
                    // setPreview(ui.value);
                    // _thumbPreview.appendTo($(ui.handle));
                } else
                    // setPreview(ui.value);

                moveBar(false);

            },

            slide: function(event, ui) {

                // setPreview(ui.value);

            },

            stop: function() {

                if (window._thumbPreview)
                    _thumbPreview.removeClass('show');

                $('.magazine').turn('page', Math.max(1, $(this).slider('value')*2 - 2));

            }
        });

        // Zoom.js
        // $('.magazine-viewport').zoom({
        //     flipbook: $('.magazine'),
        //     max: function() {
        //         if( methods.checkMobileDevice() ){
        //             return (WW * 2) /$('.magazine').width();
        //         }else{
        //             return largeMagazineWidth()/$('.magazine').width();
        //         }
        //     },
        //
        //     when: {
        //         swipeLeft: function() {
        //             $(this).zoom('flipbook').turn('next');
        //         },
        //
        //         swipeRight: function() {
        //             $(this).zoom('flipbook').turn('previous');
        //         },
        //
        //         resize: function(event, scale, page, pageElement) {
        //             if (scale==1)
        //                 loadSmallPage(page, pageElement);
        //             /*else
        //                 loadLargePage(page, pageElement);*/
        //         },
        //
        //         zoomIn: function () {
        //             // $('.thumbnails').hide();
        //             $('.made').hide();
        //             $('.magazine').removeClass('animated').addClass('zoom-in');
        //             $('.zoom-icon').removeClass('zoom-icon-in').addClass('zoom-icon-out');
        //             $('.zoom .zoom-in').hide();
        //             $('.zoom .zoom-out').show();
        //
        //             if (!window.escTip && !$.isTouch) {
        //                 escTip = true;
        //
        //                 $('<div />', {'class': 'exit-message'}).
        //                 html('<div>나가시려면 화면을 눌러주세요.</div>').
        //                 appendTo($('body')).
        //                 delay(2000).
        //                 animate({opacity:0}, 500, function() {
        //                     $(this).remove();
        //                 });
        //             }
        //         },
        //
        //         zoomOut: function () {
        //             $('.exit-message').hide();
        //             // $('.thumbnails').fadeIn();
        //             $('.made').fadeIn();
        //             $('.zoom-icon').removeClass('zoom-icon-out').addClass('zoom-icon-in');
        //             $('.zoom .zoom-out').hide();
        //             $('.zoom .zoom-in').show();
        //
        //             setTimeout(function(){
        //                 $('.magazine').addClass('animated').removeClass('zoom-in');
        //                 resizeViewport();
        //             }, 0);
        //
        //         }
        //     }
        // });

        $('#slider').slider('option', 'max', numberOfViews(flipbook));

        // Zoom event

        // if ($.isTouch)
        //     $('.magazine-viewport').bind('zoom.doubleTap', zoomTo);
        // else
        //     $('.magazine-viewport').bind('zoom.tap', zoomTo);


        // Using arrow keys to turn the page

        $(document).keydown(function(e){

            var previous = 37, next = 39, esc = 27;

            switch (e.keyCode) {
                case previous:

                    // left arrow
                    $('.magazine').turn('previous');
                    e.preventDefault();

                    break;
                case next:

                    //right arrow
                    $('.magazine').turn('next');
                    e.preventDefault();

                    break;
                case esc:

                    $('.magazine-viewport').zoom('zoomOut');
                    e.preventDefault();

                    break;
            }
        });

        // URIs - Format #/page/1

        Hash.on('^page\/([0-9]*)$', {
            yep: function(path, parts) {
                var page = parts[1];

                if (page!==undefined) {
                    if ($('.magazine').turn('is'))
                        $('.magazine').turn('page', page);
                }

            },
            nop: function(path) {

                if ($('.magazine').turn('is'))
                    $('.magazine').turn('page', 1);
            }
        });


        $(window).resize(function() {
            resizeViewport( display );
        }).bind('orientationchange', function() {
            resizeViewport();
        });

        // Events for thumbnails

        // $('.thumbnails').click(function(event) {
        //
        //     var page;
        //
        //     if (event.target && (page=/page-([0-9]+)/.exec($(event.target).attr('class'))) ) {
        //
        //         $('.magazine').turn('page', page[1]);
        //     }
        // });
        //
        // $('.thumbnails li').
        // bind($.mouseEvents.over, function() {
        //
        //     $(this).addClass('thumb-hover');
        //
        // }).bind($.mouseEvents.out, function() {
        //
        //     $(this).removeClass('thumb-hover');
        //
        // });
        //
        // if ($.isTouch) {
        //
        //     $('.thumbnails').
        //     addClass('thumbanils-touch').
        //     bind($.mouseEvents.move, function(event) {
        //         event.preventDefault();
        //     });
        //
        // } else {
        //
        //     $('.thumbnails ul').mouseover(function() {
        //
        //         $('.thumbnails').addClass('thumbnails-hover');
        //
        //     }).mousedown(function() {
        //
        //         return false;
        //
        //     }).mouseout(function() {
        //
        //         $('.thumbnails').removeClass('thumbnails-hover');
        //
        //     });
        //
        // }


        // Regions

        if ($.isTouch) {
            $('.magazine').bind('touchstart', regionClick);
        } else {
            $('.magazine').click(regionClick);
        }

        // Events for the next button

        $('.next-button').bind($.mouseEvents.over, function() {

            $(this).addClass('next-button-hover');

        }).bind($.mouseEvents.out, function() {

            $(this).removeClass('next-button-hover');

        }).bind($.mouseEvents.down, function() {

            $(this).addClass('next-button-down');

        }).bind($.mouseEvents.up, function() {

            $(this).removeClass('next-button-down');

        }).click(function() {

            $('.magazine').turn('next');

        });

        // Events for the next button

        $('.previous-button').bind($.mouseEvents.over, function() {

            $(this).addClass('previous-button-hover');

        }).bind($.mouseEvents.out, function() {

            $(this).removeClass('previous-button-hover');

        }).bind($.mouseEvents.down, function() {

            $(this).addClass('previous-button-down');

        }).bind($.mouseEvents.up, function() {

            $(this).removeClass('previous-button-down');

        }).click(function() {

            $('.magazine').turn('previous');

        });


        resizeViewport();
        $('.magazine').addClass('animated');
    }
    function initTurnjs(){
        $('#canvas').hide();
        // Load the HTML4 version if there's not CSS transform
        yepnope({
            test : Modernizr.csstransforms,
            yep: ['js/turnjs4/lib/turn.js'],
            nope: ['js/turnjs4/lib/turn.html4.min.js'],
            both: [/*'js/turnjs4/lib/zoom.min.js',*/ 'js/turnjs4/magazine.js'],
            complete: loadApp
        });
        // zoomInter();
    }



    /****************
    * the42
    ****************/
    var methods = (function(){
        function _checkMobileDevice(){
            var mobileKeyWords = new Array('Android', 'iPhone', 'iPod', 'BlackBerry', 'Windows CE', 'SAMSUNG', 'LG', 'MOT', 'SonyEricsson');
            for (var info in mobileKeyWords) {
                if (navigator.userAgent.match(mobileKeyWords[info]) != null) {
                    return true;
                }
            }
            window.isMobile = false;
            return false;
        }
        function _ratioHandler( IW,IH ){
            RATIO = IH/IW;
        }
        function _getContentsHeight(){
            if( window.isMobile ) $('.contents').css('height',WH - ($('.slider-wrap').height()+( $('.tool').height())) );
            //$('.contents .wrap').css('height',(795 / 540) * WH);
            // console.log( 795/540, WH )
        }
        function _print(){
            $("#viewPrint").print({
                addGlobalStyles : false,
                stylesheet : null,
                rejectWindow : false,
                noPrintSelector : ".no-print",
                iframe : false,
                mediaPrint : true,
                append : null,
                prepend : null
            });
        }

        return{
            checkMobileDevice:_checkMobileDevice,
            ratioHandler:_ratioHandler,
            getContentsHeight:_getContentsHeight,
            print:_print,
        }
    })();
    var menuOn = function () {
        $('.tool').addClass('onShow');
        $('.slider-wrap').addClass('onShow');
        $('.contents').addClass('onShow');
        $('.dim').addClass('onShow');
    };
    var menuOff = function () {
        $('.tool').removeClass('onShow');
        $('.slider-wrap').removeClass('onShow');
        $('.contents').removeClass('onShow');
        $('.dim').removeClass('onShow');
        $('.list-btn-on').css('display','block');
        $('.list-btn-close').css('display','none');
    };
    var setDouble = function(){
        flipbook.turn('display', 'double').turn('size', data.W, data.H).turn("center");
        display = 'double';
        window.turnjsDisplay = 'double';
        $('.button-wrap').css('width','')
    };
    var setSingle = function(){
        flipbook.turn('display', 'single');/*.turn('size', data.W/2, data.H).turn("center");*/
        display = 'single';
        window.turnjsDisplay = 'single';
        $('.button-wrap').css('width','87%');
    };


    var resizeHandler = function(){
        WW = $(window).width();
        WH = $(window).height();
        methods.ratioHandler( data.mW,data.mH );
        $('#wrapper').css('height',WH);

        if( WW > 768 ) $('.dim').removeClass('onShow');
        if( WW < 768 && !window.isMobile ){
            $('.small-screen').css('display','block');
            $('#wrapper').css('display','none');
        }else{
            $('.small-screen').css('display','none');
            $('#wrapper').css('display','block');
        }

        if( WW < 1300 ){
            if( !window.isMobile ){
                if( flipbook.turn == undefined ){
                    if( !window.isInit && !isTimerInited){
                        initTimer = setInterval(resizeHandler,100);
                        isTimerInited = true;
                        // console.log('- under1300, undefined')
                    }
                }else{
                    window.turnjsDisplay == 'single' ? setSingle() : setDouble();

                    if( !window.isInit ) clearInterval(initTimer);
                    window.isInit = true;
                    // console.log('- under1300, complete')
                }
            }
            $('.page-index-wrap input').prop('type','number')
        }else{
            if( flipbook.turn == undefined ){
                if( !window.isInit && !isTimerInited){
                    initTimer = setInterval(resizeHandler,100);
                    isTimerInited = true;
                    // console.log('- upper1300, undefined')
                }
            }else{
                window.turnjsDisplay == 'single' ? setSingle() : setDouble();

                if( !window.isInit ) clearInterval(initTimer);
                window.isInit = true;
                // console.log('- upper1300, complete')
            }
            $('.page-index-wrap input').prop('type','text')
        }
    };

    var printPage = function () {
        for(var i = 1;i < data.page + 1;i++){
            var option = $("<option>"+i+"</option>");
            $('.option select').append(option);
        }
    };

    var zoomEvent = function () {
        $('.plus').on('click',function () {
            if( zoomEnd == true ){
                zoomPointOffset = Math.floor((($('.point').css('top').split('px')[0]) / $('.bar').height()) * 100);
                if(zoomLangth < 2){
                    zoomLangth = zoomLangth + 0.25;
                }
                // console.log(zoomPointOffset)
                $('.magazine').addClass('zoom-in');
                if(zoomPointOffset > 10 ){
                    $('.point').css('top', zoomPointOffset - 20 + '%');
                    zoomEnd = false;
                }

                $('.magazine').draggable({
                    // containment: ".magazine-viewport",
                    start:true,
                    disabled:false
                });

                $('.magazine').css('transform','scale(' + zoomLangth + ')');
            }
        });

        $('.minus').on('click',function () {
            if( zoomEnd == true ) {
                zoomPointOffset = Math.floor((($('.point').css('top').split('px')[0]) / $('.bar').height()) * 100);
                if (zoomLangth > 1) {
                    zoomLangth = zoomLangth - 0.25;
                }
                if (zoomPointOffset < 90) {
                    $('.point').css('top', zoomPointOffset + 20 + '%');
                    zoomEnd = false;
                }
                $('.magazine').addClass('zoom-in');
                $('.magazine').css('transform', 'scale(' + zoomLangth + ')');
                if (zoomLangth == 1) {
                    $('.magazine').draggable("option", "disabled", true);
                    $('.magazine').css({'left': '', 'top': ''});
                    window.resizeViewport();
                }
            }
        })
    };

    var printOption = function () {
        if($('#curr-page').is(':checked')){
            $('#viewPrint').empty();
            currPage = Number($('#curr-page-select option:selected').val());
            var printPageImg = $("<img src=pages/" + currPage + ".jpg></img>");
            $('#viewPrint').append(printPageImg);
        }else if($('#range-page').is(':checked')){
            firstPage = Number($('#first-page option:selected').val());
            lastPage = Number($('#last-page option:selected').val());
            $('#viewPrint').empty()
            for(var i = firstPage;i < lastPage + 1;i++){
                var printPageImg = $("<img src=pages/" + i + ".jpg></img>");
                $('#viewPrint').append(printPageImg);
            }
            $('#first-page option').prop('disabled',false);
            for(var i = lastPage;i < data.page; i++){
                $('#first-page option').eq(i).prop('disabled',true);
            }
        }else{
            $('#viewPrint').empty()
            for(var i = 1;i < data.page + 1;i++){
                var printPageImg = $("<img src=pages/" + i + ".jpg></img>");
                $('#viewPrint').append(printPageImg);
            }
        }
    };

    var getSetJsonData = function(){
        listData = window.contentData;
        for( var i=0; i < listData.pagelist.length ; i++ ){
            var liData = "<li class='" + i + "'><a href='#page/" + listData.pagelist[i].num + "'>" + listData.pagelist[i].title + "</a></li>";
            $('.contents. .wrap ul').append(liData);
        }
    };
    var addEvent = function(){
        $(window).on('resize',resizeHandler);
        resizeHandler();

        pageIndexField.on('keydown',function (key) {
            var pageIndexFieldText = pageIndexField.val();
            if ( key.keyCode == 13 ) {
                if(data.page < pageIndexFieldText){
                    pageIndexFieldText = data.page;
                    pageIndexField.val(data.page);
                }
                flipbook.turn("page", pageIndexFieldText);
            }
        });

        $('.zoom .zoom-in').on('click',function () {
            flipbookViewPort.zoom("zoomIn");
            menuOff();

        });
        $('.zoom .zoom-out').on('click',function () {
            flipbookViewPort.zoom("zoomOut");
            menuOff();
        });

        $('.hamberger-on').on('click',function () {
            menuOn();
        });
        $('.hamberger-close').on('click',function () {
            menuOff();
        });
        $('.print').on('click',function () {
            $('.print-layer').show();
        });

        $('#print-close').on('click',function () {
            $('.print-layer').hide();
        });

        $('#print').on('click',methods.print);

        $('.dim').on('click',function () {
            menuOff();
        });
        $('.max-page').text(data.page);

        $('.list-btn-on').on('click',function () {
            $('.contents').addClass('onShow');
            $('.list-btn-close').css('display','block');
            $('.list-btn-on').css('display','none');
        });
        $('.list-btn-close').on('click',function () {
            $('.contents').removeClass('onShow');
            $('.list-btn-on').css('display','block');
            $('.list-btn-close').css('display','none');
        });

        printPage();
        $('select').on('change',printOption);
        $('input[name=page-select]').on('change',printOption);
        $('#viewPrint').append(printPageImg);
        $('#curr-page-select').on('click',function () {
            $('#curr-page').prop('checked',true);
        });
        $('#first-page,#last-page').on('click',function () {
            $('#range-page').prop('checked',true);
        });
    };

    var _init = function( ebookData ){
        getSetJsonData();
        data = ebookData;

        $('h1 img').attr('src',data.logo);
        $('h2').text(data.title);
        $('title').text(data.title);

        zoomEvent();
        $('.point').on('transitionend',function(){
            zoomEnd = true
            });
        initTurnjs();
        addEvent();
        methods.getContentsHeight();
        $('#wrapper').addClass('onShow');
    };

    return{
        init:_init
    }
})();